;----------------------------------------;
; SetResolution, Ver. 1.0, Paul Brennick ;
; Concept & Original Code - CycleSaddles ;
;----------------------------------------;
    .386
    .model  flat, stdcall
    option  casemap :none

    include \GeneSys\include\Windows.inc
    include \GeneSys\macros\macros.asm
    uselib  user32,kernel32,gdi32

SpecialProc PROTO  :DWORD, :DWORD, :DWORD, :DWORD

.const
;---------------------------------------
IDC_RBN1            equ 1001
IDC_RBN2            equ 1002
IDC_SWITCH          equ 1003
IDC_TITLE_1         equ 4001
IDC_CLOSE           equ 4002

DM_BITSPERPEL       equ 40000h
DM_PELSWIDTH        equ 80000h
DM_PELSHEIGHT       equ 100000h
DM_DISPLAYFLAGS     equ 200000h
DM_DISPLAYFREQUENCY equ 400000h

.data
;---------------------------------------
szFontName  db  "MS Sans Serif", 0
DlgMain     db  'Special', 0

.data?
;---------------------------------------
hInstance   dd  ?
hFont1      dd  ?
hWnd01      dd  ?
hWnd02      dd  ?

resolution  DEVMODE <>

.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    invoke  DialogBoxParam, hInstance, addr DlgMain, 0, addr SpecialProc, 0
    invoke  ExitProcess, eax

SpecialProc PROC  hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
    .if uMsg == WM_INITDIALOG
      invoke  CreateFont, 24, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, addr szFontName
      mov     hFont1, eax
      invoke  SendDlgItemMessage, hWin, IDC_TITLE_1, WM_SETFONT, hFont1, 0
      invoke  GetDlgItem, hWin, IDC_RBN1
      mov     hWnd01, eax
      invoke  GetDlgItem, hWin, IDC_RBN2
      mov     hWnd02, eax
      invoke  SendMessage, hWnd01, BM_SETCHECK, BST_CHECKED, 0
      invoke  SendMessage, hWnd02, BM_SETCHECK, BST_UNCHECKED, 0
      ret
    .elseif uMsg == WM_CLOSE        ; Close
      invoke  EndDialog, hWin, 0    ; Tell the dialog box to close itself
      push    1                     ; Set Exit Code
      pop     eax                   ; Get Exit Code
      ret                           ; Exit the Program
    .elseif uMsg == WM_COMMAND      ; Call to Command Parser?
      mov     eax, wParam
      .if eax == IDC_SWITCH
        invoke  SendMessage, hWnd01, BM_GETSTATE, 0, 0
        .if eax == BST_CHECKED
          mov     resolution.dmFields,DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or \
                  DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY
          mov     resolution.dmBitsPerPel, 32           ; Color bits
          mov     resolution.dmPelsWidth, 1024          ; X pixel width 
          mov     resolution.dmPelsHeight, 768          ; Y pixel height 
          mov     resolution.dmDisplayFlags, 0          ; Display mode noninterlaced
          mov     resolution.dmDisplayFrequency, 85     ; Monitor Display Frequency
          mov     resolution.dmSize, sizeof resolution  ; Size of resolution structure
        .else
          mov     resolution.dmFields,DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or \
                  DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY
          mov     resolution.dmBitsPerPel, 32           ; Color bits
          mov     resolution.dmPelsWidth,1280           ; X pixel width 
          mov     resolution.dmPelsHeight, 1024         ; Y pixel height 
          mov     resolution.dmDisplayFlags, 0          ; Display mode noninterlaced
          mov     resolution.dmDisplayFrequency, 60     ; Monitor Display Frequency
          mov     resolution.dmSize, sizeof resolution  ; Size of resolution structure
        .endif
        invoke  ChangeDisplaySettings, addr resolution, 0
      .elseif eax == IDC_CLOSE
        invoke  SendMessage, hWin, WM_CLOSE, NULL, NULL
        ret
      .endif
    .endif
    xor     eax, eax
    ret
;--------------------------------------
SpecialProc   endp

    end     start

